<template>
  <div>
    <CCard>
      <CCardHeader>
        <div>
          <font-awesome-icon :icon="['fas', 'user-friends']" />
          <strong>Member List</strong>
        </div>
        <div class="card-header-actions">
          <CButton
            variant="ghost"
            color="primary"
            :disabled="loading"
            @click="onShowDetail(0)"
          >
            <font-awesome-icon :icon="['fas', 'user-plus']" class="width-1x" />
            Add Member
          </CButton>
        </div>
      </CCardHeader>

      <CCardBody>
        <user-search-form
          :default-condition="condition"
          :loading="loading"
          @submit="onSearch"
        />

        <app-pagination
          :total="total"
          :page-size="limit"
          :current-page="page"
          :disabled="loading"
          @page-change="onPageChange"
        />

        <user-table
          :data="data"
          :loading="loading"
          @show-detail="onShowDetail"
          @delete="onConfirmDelete"
        />

        <app-pagination
          :total="total"
          :page-size="limit"
          :current-page="page"
          :disabled="loading"
          @page-change="onPageChange"
        />
      </CCardBody>
    </CCard>

    <user-detail-modal
      :id="selectedId"
      ref="userDetailModal"
    />

    <app-delete-confirm-dialog
      ref="deleteConfirmDialog"
      :name="'user'"
      @confirm="onDelete"
    />
  </div>
</template>

<script>
import User from '~/models/User'

import UserSearchForm from '~/components/organisms/users/UserSearchForm'
import UserTable from '~/components/organisms/users/UserTable'
import AppPagination from '~/components/atoms/AppPagination'
import UserDetailModal from '~/components/organisms/users/UserDetailModal'
import AppDeleteConfirmDialog from '~/components/molecules/AppDeleteConfirmDialog'

import AsyncLoading from '~/mixins/do-async-loading'
import ConditionHandler from '~/mixins/condition'
import SearchFormHandler from '~/mixins/search-form'
import Paginator from '~/mixins/paginator'

export default {
  components: {
    UserSearchForm,
    UserTable,
    AppPagination,
    UserDetailModal,
    AppDeleteConfirmDialog
  },

  mixins: [
    AsyncLoading,
    ConditionHandler,
    SearchFormHandler,
    Paginator
  ],

  data () {
    return {
      resourceTypeName: 'user',
      total: 0,
      data: [],
      selectedId: null
    }
  },

  mounted () {
    this.refresh()
  },

  methods: {
    /**
     * Call API get users by condition search
     * Show data on table result
     *
     * @return {Object} API response for error handle
     */
    async fetch () {
      const res = await this.$dam.getUserList(this.query)

      if (Array.isArray(res.data) && res.data.length) {
        this.total = res.meta.total
        this.data = res.data.map(item => new User(item))
      }

      return res
    },

    /**
     * Open user detail modal
     *
     * @param {Object} user - Current user
     */
    onShowDetail (id) {
      this.setSelectedId(id)
      this.$refs.userDetailModal.open()
    },

    /**
     * Open confirm delete
     * If confirm then call delete user
     * Else cancel
     *
     * @param {String} id - User id
     */
    onConfirmDelete (id) {
      this.setSelectedId(id)
      this.$refs.deleteConfirmDialog.open()
    },

    /**
     * Call API delete.
     *
     * @param {String} selectedId - User id
     */
    async delete (selectedId) {
      await this.$dam.deleteUser({ id: selectedId })
    },

    /**
     * Set selectedId
     *
     * @param {Number} id - Id is selected
     */
    setSelectedId (id) {
      this.selectedId = id
    }
  }
}
</script>
